//+------------------------------------------------------------------+
//|                                        pivot with time shift.mq4 |
//|                                                           mladen |
//| pivot, middle and camarilla code by igorad                       |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1

//
//
//
//
//

extern string _                = "parameters";
extern int    CountDays        = 10;
extern int    TimeShift        = 0;
extern bool   Plot_pivots      = true;
extern bool   Plot_middle      = false;
extern bool   Plot_camarilla   = false;
extern int    Pivot_Widths     = 2;
extern int    Midpoint_Widths  = 1;
extern int    Camarilla_Widths = 1;

//
//
//
//
//

double dummy[];
double data[][5];

//
//
//
//
//

int    shiftInSeconds;
int    accountNo;
string accountBroker;
string fileName;
datetime time1,time2;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,dummy);
   shiftInSeconds = TimeShift*3600;
   fileName       = WindowExpertName();
   return(0);
}

int deinit() { ObjDel(); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define aHi    0
#define aLo    1
#define aOpen  2
#define aClose 3
#define noData 4

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars < 0)   return(-1);
   if(counted_bars > 0)   counted_bars--;
         if(_!="getBarNumbers") if(Period()>PERIOD_H4) return(0);
         if(_=="getBarNumbers") { dummy[0] = MathMin(Bars-counted_bars,Bars-1); return(0); }
           
      //
      //
      //
      //
      //

      limit  = MathMax(Bars-counted_bars,MathMin(iCustom(NULL,PERIOD_D1,fileName,"getBarNumbers",0,0)*PERIOD_D1/Period(),Bars-1));
            
      //
      //
      //
      //
      //
      
      int dataSize = ArrayRange(data,0);
      if (accountNo != AccountNumber() || accountBroker != AccountCompany())
      {
         accountNo       = AccountNumber();
         accountBroker   = AccountCompany();
                limit    = Bars-1;
                dataSize = 0;
      }
      
      //
      //
      //
      //
      //
      
      if (dataSize != iBars(NULL,PERIOD_D1))
      {
         int oldSize  = dataSize;
             dataSize = iBars(NULL,PERIOD_D1);
                ArrayResize(data,dataSize);
                for (i=dataSize-1; i>oldSize; i--)
                {
                   data[i][noData] = 1;
                   data[i][aHi]    = -99999999999;
                   data[i][aLo]    =  99999999999;
                   data[i][aOpen]  =  0;
                   data[i][aClose] =  0;
                }
      }

   //
   //
   //
   //
   //

   int dayCount =  0;
   int dayShift = -1;

      for(i = limit; i >= 0; i--)
      {
         dayShift = iBarShift(NULL,PERIOD_D1,Time[i]-shiftInSeconds);
      
            string   st = TimeToStr(Time[i],TIME_DATE);
            datetime ts = StrToTime(st+" 00:00")-shiftInSeconds;
            datetime te = StrToTime(st+" 23:59")-shiftInSeconds;
      
         //
         //
         //
         //
         //
      
         int r = dataSize-dayShift-1;
         if (Time[i] >= ts && Time[i] < te)
         {
            dayCount++;
            data[r][aLo]    = MathMin(Low[i] ,data[r][aLo]);
            data[r][aHi]    = MathMax(High[i],data[r][aHi]);
            data[r][aClose] = Close[i];
            data[r][noData] = 0;
            if (data[r][aOpen]==0)
                data[r][aOpen] = Open[i];
         }
      }
   if (dayCount == 0) { Print("Pivot - No data collected"); return(0); }
   
   //
   //
   //
   //
   //

      ObjDel();
      ts = StrToTime(TimeToStr(Time[0],TIME_DATE))-shiftInSeconds;

      //
      //
      //
      //
      //
      
      
      for(int shift = CountDays-1; shift >= 0; shift--)
      {
         if (shift==0 && (Time[0]-shiftInSeconds) < ts)
               r = dataSize-shift-2;
         else  r = dataSize-shift-1;

         time1 = iTime(NULL,PERIOD_D1,shift)-shiftInSeconds;
         time2 = time1+PERIOD_D1*60;
            if (TimeDayOfWeek(time1)==0) time1 = iTime(NULL,PERIOD_D1,shift);
            if (TimeDayOfWeek(time2)==5) time2 = iTime(NULL,PERIOD_D1,shift-1);

         //
         //
         //
         //
         //
      
         double high  = data[r-1][aHi];
         double low   = data[r-1][aLo];
         double open  = data[r-1][aOpen];
         double close = data[r-1][aClose];
       
         double P  = (high+low+close)/3.0;
         double R1 = 2*P-low;
         double R2 = P+(high - low);
         double R3 = (2*P)+(high-(2*low));
         double S1 = 2*P-high;
         double S2 = P-(high - low);
         double S3 = (2*P)-((2*high)-low);
         
         double M0=0.5*(S2+S3);
         double M1=0.5*(S1+S2);
         double M2=0.5*(P+S1);
         double M3=0.5*(P+R1);  
         double M4=0.5*(R1+R2);
         double M5=0.5*(R2+R3);
         
         double Range = high - low;
         double H4 = close + (Range * 1.1/2.0);
         double H3 = close + (Range * 1.1/4.0);
         double H2 = close + (Range * 1.1/6.0);
         double H1 = close + (Range * 1.1/12.0);

         double L1 = close - (Range * 1.1/12.0);
         double L2 = close - (Range * 1.1/6.0);
         double L3 = close - (Range * 1.1/4.0);
         double L4 = close - (Range * 1.1/2.0);
       
        
         double pstyle = 0;
         double mstyle = 3;
         double cstyle = 1;
         int num = shift;
       
         PlotLine("PP["+num+"]",P,Aqua,pstyle, Pivot_Widths);
            if(Plot_pivots)
            {
               PlotLine("R1["+num+"]",R1,Red,pstyle, Pivot_Widths);
               PlotLine("R2["+num+"]",R2,Orange,pstyle, Pivot_Widths);
               PlotLine("R3["+num+"]",R3,Gold,pstyle, Pivot_Widths);
               PlotLine("S1["+num+"]",S1,MediumSeaGreen,pstyle, Pivot_Widths);
               PlotLine("S2["+num+"]",S2,Lime,pstyle, Pivot_Widths);
               PlotLine("S3["+num+"]",S3,GreenYellow,pstyle, Pivot_Widths);
            }
            if(Plot_middle)
            {
               PlotLine("M0["+num+"]",M0,LightBlue,mstyle, Midpoint_Widths);
               PlotLine("M1["+num+"]",M1,DeepSkyBlue,mstyle, Midpoint_Widths);
               PlotLine("M2["+num+"]",M2,MediumSlateBlue,mstyle, Midpoint_Widths);
               PlotLine("M3["+num+"]",M3,Tomato,mstyle, Midpoint_Widths);
               PlotLine("M4["+num+"]",M4,Chocolate,mstyle, Midpoint_Widths);
               PlotLine("M5["+num+"]",M5,Pink,mstyle, Midpoint_Widths);
            }
            if(Plot_camarilla)
            {
               PlotLine("H4["+num+"]",H4,LightBlue,cstyle, Camarilla_Widths);
               PlotLine("H3["+num+"]",H3,DeepSkyBlue,cstyle, Camarilla_Widths);
               PlotLine("H2["+num+"]",H2,MediumSlateBlue,cstyle, Camarilla_Widths);
               PlotLine("H1["+num+"]",H1,RoyalBlue,cstyle, Camarilla_Widths);
               PlotLine("L1["+num+"]",L1,Chocolate,cstyle, Camarilla_Widths);
               PlotLine("L2["+num+"]",L2,Orange,cstyle, Camarilla_Widths);
               PlotLine("L3["+num+"]",L3,Goldenrod,cstyle, Camarilla_Widths);
               PlotLine("L4["+num+"]",L4,Yellow,cstyle, Camarilla_Widths);
            }
      }

   //
   //
   //
   //
   //

   return(0);      
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ObjDel()
{
   for (int num =0; num<=CountDays; num++)
   {
      ObjectDelete("PP["+num+"]");
      ObjectDelete("R1["+num+"]");
      ObjectDelete("R2["+num+"]");
      ObjectDelete("R3["+num+"]");
      ObjectDelete("S1["+num+"]");
      ObjectDelete("S2["+num+"]");
      ObjectDelete("S3["+num+"]");
      
      ObjectDelete("M0["+num+"]");
      ObjectDelete("M1["+num+"]");
      ObjectDelete("M2["+num+"]");
      ObjectDelete("M3["+num+"]");
      ObjectDelete("M4["+num+"]");
      ObjectDelete("M5["+num+"]");
      
      ObjectDelete("H1["+num+"]");
      ObjectDelete("H2["+num+"]");
      ObjectDelete("H3["+num+"]");
      ObjectDelete("H4["+num+"]");
      ObjectDelete("L1["+num+"]");
      ObjectDelete("L2["+num+"]");
      ObjectDelete("L3["+num+"]");
      ObjectDelete("L4["+num+"]");
   }
}
void PlotLine(string name,double value,double line_color,double style, int width)
{
   ObjectCreate(name,OBJ_TREND,0,time1,value,time2,value);
      ObjectSet(name,OBJPROP_WIDTH,width);
      ObjectSet(name,OBJPROP_STYLE,style);
      ObjectSet(name,OBJPROP_RAY,false);
      ObjectSet(name,OBJPROP_BACK,true);
      ObjectSet(name,OBJPROP_COLOR,line_color);
}